LogTo("/home/agustin/gap-4.10.1/bin/ufo/cleft-br2a-q-z.log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];

#########################################################
Print("\n \n Case  lambda1, lambda2, lambda221, lambda112 nonzero\n");

#q21=q

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q12:=-q*F1;;
q21:=q*F1;;
q22:=-q*F1;;

y13:=[[[2,2,2]],[F1]];
y26:=[[[1,1,1,1,1,1]],[F1]];
x13:=[[[4,4,4]],[F1]];
x26:=[[[3,3,3,3,3,3]],[F1]];

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221d,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
xna2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;

s112:=AddNP(yna2,xna2,1,1);;

r112:=StrongNormalFormNP(AddNP(dna2,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

yna2d:=AddNP(yna2,MulNP(y2,y12),1,-(-4*E(3)^2)*t1);;
dna2d:=AddNP(dna2,MulNP(d2,d12),1,-(-4*E(3)^2)*t1);;

s112d:=AddNP(yna2d,xna2,1,1);;
r112d:=StrongNormalFormNP(AddNP(dna2d,s112d,1,-1),G1);;

Print("\n The difference now is \n");
PrintNP(r112d);

yna2dd:=AddNP(yna2d,MulNP(y2,y12),1,4*q^2*t1);;
dna2dd:=AddNP(dna2d,MulNP(d2,d12),1,4*q^2*t1);;

s112dd:=AddNP(yna2dd,xna2,1,1);;
r112dd:=StrongNormalFormNP(AddNP(dna2dd,s112dd,1,-1),G1);;

Print("\n The difference now is \n");
PrintNP(r112dd);


############################################################

Print("\n \n Case  lambda1, lambda2, nonzero\n");

#q21=q^2

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q21:=q^2*F1;;
q12:=q22^-1*q21^-1*F1;;
q22:=-q*F1;;


y13:=[[[2,2,2]],[F1]];
y26:=[[[1,1,1,1,1,1]],[F1]];
x13:=[[[4,4,4]],[F1]];
x26:=[[[3,3,3,3,3,3]],[F1]];

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
xna2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;

s112:=AddNP(yna2,xna2,1,1);;

r112:=StrongNormalFormNP(AddNP(dna2,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

yna2d:=AddNP(yna2,MulNP(y2,y12),1,-(-4)*t1);;
dna2d:=AddNP(dna2,MulNP(d2,d12),1,-(-4)*t1);;

s112d:=AddNP(yna2d,xna2,1,1);;
r112d:=StrongNormalFormNP(AddNP(dna2d,s112d,1,-1),G1);;

Print("\n The difference now is \n");
PrintNP(r112d);

##########################################################

Print("\n \n Case  lambda1, lambda2, nonzero\n");

#q21=1

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q21:=F1;;
q12:=q22^-1*q21^-1*F1;;
q22:=-q*F1;;


y13:=[[[2,2,2]],[F1]];
y26:=[[[1,1,1,1,1,1]],[F1]];
x13:=[[[4,4,4]],[F1]];
x26:=[[[3,3,3,3,3,3]],[F1]];

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);
y221d:=AddNP(y221,[[[]],[F1]],1,-t3);

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
xna2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;

s112:=AddNP(yna2,xna2,1,1);;

r112:=StrongNormalFormNP(AddNP(dna2,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

yna2d:=AddNP(yna2,MulNP(y2,y12),1,-(-4*E(3))*t1);;
dna2d:=AddNP(dna2,MulNP(d2,d12),1,-(-4*E(3))*t1);;

s112d:=AddNP(yna2d,xna2,1,1);;
r112d:=StrongNormalFormNP(AddNP(dna2d,s112d,1,-1),G1);;

Print("\n The difference now is \n");
PrintNP(r112d);



#########################################################
Print("\n \n Case  lambda1, lambda221 zero\n");


t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;
t3:=Indeterminate(Rationals,"t3");;

F:=Field(t1,t2,t3);
F1:=1;;
q:=E(3);
q11:=q*F1;;
q12:=q*F1;;
q21:=-q*F1;;
q22:=-q*F1;;


y13:=[[[2,2,2]],[F1]];
y26:=[[[1,1,1,1,1,1]],[F1]];
x13:=[[[4,4,4]],[F1]];
x26:=[[[3,3,3,3,3,3]],[F1]];

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;

d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;

dna2:=StrongNormalFormNP(MulNP(d112,d112),G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xna2:=StrongNormalFormNP(MulNP(x112,x112),G1);;

yna2:=StrongNormalFormNP(MulNP(y112,y112),G1);;

s112:=AddNP(yna2,xna2,1,1);;
r112:=StrongNormalFormNP(AddNP(dna2,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);


