LogTo("/home/edwin/br(2,a)/ufo 7/cleft-ufo7b.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];

q:=E(12);;

Print("\n \n Case lambda2 nonzero, q12=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q11:=-q^-2*F1;;
q12:=1;;
q21:=q^-1*q12^-1*F1;;
q22:=-1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

y1c:=MulNP(y1,MulNP(y1,y1));;
x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;

Print("The ideal is: \n");

K1:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22
];

PrintNPList(K1);

G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
d11212:=AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22);;
d1121212:=AddNP(MulNP(d11212,d12),MulNP(d12,d11212),1,-q11^3*q12^3*q21^2*q22^2);;
d:=StrongNormalFormNP(d1121212,G1);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);;
x11212:=AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22);;
x1121212:=AddNP(MulNP(x11212,x12),MulNP(x12,x11212),1,-q11^3*q12^3*q21^2*q22^2);;
x:=StrongNormalFormNP(x1121212,G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;
y1121212:=AddNP(MulNP(y11212,y12),MulNP(y12,y11212),1,-q11^3*q12^3*q21^2*q22^2);;
y:=StrongNormalFormNP(y1121212,G1);;

s:=AddNP(y,x,1,1);;
z:=StrongNormalFormNP(AddNP(d,s,1,-1),G1);;
Print("The difference is \n");

PrintNP(z);

#########################################################################################
Print("\n \n Case lambda2 nonzero, q12=-1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q11:=-q^-2*F1;;
q12:=-1;;
q21:=q^-1*q12^-1*F1;;
q22:=-1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

y1c:=MulNP(y1,MulNP(y1,y1));;
x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;

K1:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22
];;

Print("The ideal is: \n");

PrintNPList(K1);

G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
d11212:=AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22);;
d1121212:=AddNP(MulNP(d11212,d12),MulNP(d12,d11212),1,-q11^3*q12^3*q21^2*q22^2);;
d:=StrongNormalFormNP(d1121212,G1);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);;
x11212:=AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22);;
x1121212:=AddNP(MulNP(x11212,x12),MulNP(x12,x11212),1,-q11^3*q12^3*q21^2*q22^2);;
x:=StrongNormalFormNP(x1121212,G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;
y1121212:=AddNP(MulNP(y11212,y12),MulNP(y12,y11212),1,-q11^3*q12^3*q21^2*q22^2);;
y:=StrongNormalFormNP(y1121212,G1);;

s:=AddNP(y,x,1,1);;
z:=StrongNormalFormNP(AddNP(d,s,1,-1),G1);;
Print("The difference is \n");

PrintNP(z);


#########################################################################################

Print("\n \n Case lambda1 nonzero, q21=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q11:=-q^-2*F1;;
q21:=1;;
q12:=q^-1*q21^-1*F1;;
q22:=-1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

y1c:=MulNP(y1,MulNP(y1,y1));;
x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;

K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22
];;

Print("The ideal is: \n");

PrintNPList(K1);

G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
d11212:=AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22);;
d1121212:=AddNP(MulNP(d11212,d12),MulNP(d12,d11212),1,-q11^3*q12^3*q21^2*q22^2);;
d:=StrongNormalFormNP(d1121212,G1);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);;
x11212:=AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22);;
x1121212:=AddNP(MulNP(x11212,x12),MulNP(x12,x11212),1,-q11^3*q12^3*q21^2*q22^2);;
x:=StrongNormalFormNP(x1121212,G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;
y1121212:=AddNP(MulNP(y11212,y12),MulNP(y12,y11212),1,-q11^3*q12^3*q21^2*q22^2);;
y:=StrongNormalFormNP(y1121212,G1);;

s:=AddNP(y,x,1,1);;
z:=StrongNormalFormNP(AddNP(d,s,1,-1),G1);;
Print("The difference is \n");

PrintNP(z);
#########################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(3): \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q11:=-q^-2*F1;;
q21:=E(3)*F1;;
q12:=q^-1*q21^-1*F1;;
q22:=-1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

y1c:=MulNP(y1,MulNP(y1,y1));;
x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;

K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22
];;

Print("The ideal is: \n");

PrintNPList(K1);

G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
d11212:=AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22);;
d1121212:=AddNP(MulNP(d11212,d12),MulNP(d12,d11212),1,-q11^3*q12^3*q21^2*q22^2);;
d:=StrongNormalFormNP(d1121212,G1);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);;
x11212:=AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22);;
x1121212:=AddNP(MulNP(x11212,x12),MulNP(x12,x11212),1,-q11^3*q12^3*q21^2*q22^2);;
x:=StrongNormalFormNP(x1121212,G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;
y1121212:=AddNP(MulNP(y11212,y12),MulNP(y12,y11212),1,-q11^3*q12^3*q21^2*q22^2);;
y:=StrongNormalFormNP(y1121212,G1);;

s:=AddNP(y,x,1,1);;
z:=StrongNormalFormNP(AddNP(d,s,1,-1),G1);;
Print("The difference is \n");

PrintNP(z);

#########################################################################################
Print("\n \n Case lambda1 nonzero, q21=E(3)^2: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q11:=-q^-2*F1;;
q21:=E(3)^2*F1;;
q12:=q^-1*q21^-1*F1;;
q22:=-1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

y1c:=MulNP(y1,MulNP(y1,y1));;
x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;

K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22
];;

Print("The ideal is: \n");

PrintNPList(K1);

G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;
d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
d11212:=AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22);;
d1121212:=AddNP(MulNP(d11212,d12),MulNP(d12,d11212),1,-q11^3*q12^3*q21^2*q22^2);;
d:=StrongNormalFormNP(d1121212,G1);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12);;
x11212:=AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22);;
x1121212:=AddNP(MulNP(x11212,x12),MulNP(x12,x11212),1,-q11^3*q12^3*q21^2*q22^2);;
x:=StrongNormalFormNP(x1121212,G1);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;
y1121212:=AddNP(MulNP(y11212,y12),MulNP(y12,y11212),1,-q11^3*q12^3*q21^2*q22^2);;
y:=StrongNormalFormNP(y1121212,G1);;

s:=AddNP(y,x,1,1);;
z:=StrongNormalFormNP(AddNP(d,s,1,-1),G1);;
Print("The difference is \n");

PrintNP(z);

quit;


