#LogTo("/home/agustin/Dropbox/Matemática/in-progress/ufo/gap/lift-ufo8a.log");

LogTo("/home/aigarcia/gap4r8/bin/ufo/lift-ufo8a.log");


# Remarks:
# The diagram is symmetric, so cases mu1 nonzero or mu2 nonzero are equivalent.
# We develop case mu2 nonzero. Without loss of generality, we shall assume mu2=1. 

LoadPackage("GBNP");

GBNP.ConfigPrint("a2","a122","a12","a112","a1","g2","g1","y2","y122","y12","y112","y1");

q:=E(12);;

q11:=-q^2;;

q22:=q11;;

c1:=Indeterminate(Rationals,"c1");;
c2:=Indeterminate(Rationals,"c2");;


a1:=[[[5]],[1]];;

a122:=[[[4]],[1]];;

a12:=[[[3]],[1]];;

a112:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

g1:=[[[7]],[1]];;

g2:=[[[6]],[1]];;

y1:=[[[12]],[1]];;

y122:=[[[11]],[1]];;

y12:=[[[10]],[1]];;

y112:=[[[9]],[1]];;

y2:=[[[8]],[1]];;

y1f:=MulNP(y1,MulNP(y1,y1));;
a1f:=MulNP(a1,MulNP(a1,a1));;
y2f:=MulNP(y2,MulNP(y2,y2));;
a2f:=MulNP(a2,MulNP(a2,a2));;
g2f:=MulNP(g2,MulNP(g2,g2));;
g1f:=MulNP(g1,MulNP(g1,g1));;

c2:=1;;

y2d:=AddNP(y2f,[ [ [] ],[1]  ],1,-c2);;
a2d:=AddNP(AddNP(a2f,[ [ [] ],[1]  ],1,-c2),g2f,1,c2);;


Print("Case mu2 nonzero, q12=1: \n");


q12:=1;;

q21:=q*q12^-1;;



b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;

g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;

ra12:=AddNP(a12,AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12),1,-1);;
ra112:=AddNP(a112,AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12),1,-1);;
ra122:=AddNP(a122,AddNP(MulNP(a12,a2),MulNP(a2,a12),1,-q12*q22),1,-1);;

ry12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
ry112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
ry122:=AddNP(y122,AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22),1,-1);;

h:=(1+q+q^2)*q^4*q12;;

y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
y12c:=MulNP(y12,y12);;
yr:=AddNP(y1122,y12c,1,-h);;

a1122:=AddNP(MulNP(a1,a122),MulNP(a122,a1),1,-q11*q12^2);;
a12c:=MulNP(a12,a12);;
ar:=AddNP(a1122,a12c,1,-h);;

K:=[
y1f,a1f,
y2d,a2d,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g,
ra12,ra112,ra122,
ry12,ry112,ry122,
yr,ar
];;


Print("The ideal is: \n");

PrintNPList(K);

G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;


g12:=MulNP(g1,g2);;
gg1:=StrongNormalFormNP(g12,G);;
gg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
gg4:=StrongNormalFormNP(MulNP(gg2,gg2),G);;
gg6:=StrongNormalFormNP(MulNP(gg2,gg4),G);;
gg12:=StrongNormalFormNP(MulNP(gg6,gg6),G);;

aa1:=StrongNormalFormNP(a12,G);;
aa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
aa4:=StrongNormalFormNP(MulNP(aa2,aa2),G);;
aa6:=StrongNormalFormNP(MulNP(aa2,aa4),G);;
aa8:=StrongNormalFormNP(MulNP(aa2,aa6),G);;
aa10:=StrongNormalFormNP(MulNP(aa2,aa8),G);;
aa12:=StrongNormalFormNP(MulNP(aa2,aa10),G);;

yy1:=StrongNormalFormNP(y12,G);;
yy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
yy4:=StrongNormalFormNP(MulNP(yy2,yy2),G);;
yy6:=StrongNormalFormNP(MulNP(yy2,yy4),G);;
yy8:=StrongNormalFormNP(MulNP(yy2,yy6),G);;
yy10:=StrongNormalFormNP(MulNP(yy2,yy8),G);;
yy12:=StrongNormalFormNP(MulNP(yy2,yy10),G);;

r:=AddNP(AddNP(r12,aa12,1,-1),MulNP(gg12,yy12),1,-1);;

Print("The difference is \n");

PrintNP(StrongNormalFormNP(r,G));

###############################################################################################
###############################################################################################
###############################################################################################

Print("Case mu2 nonzero, q12=E(3): \n");

q12:=E(3);;

q21:=q*q12^-1;;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;

g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;

ra12:=AddNP(a12,AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12),1,-1);;
ra112:=AddNP(a112,AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12),1,-1);;
ra122:=AddNP(a122,AddNP(MulNP(a12,a2),MulNP(a2,a12),1,-q12*q22),1,-1);;

ry12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
ry112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
ry122:=AddNP(y122,AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22),1,-1);;

h:=(1+q+q^2)*q^4*q12;;

y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
y12c:=MulNP(y12,y12);;
yr:=AddNP(y1122,y12c,1,-h);;

a1122:=AddNP(MulNP(a1,a122),MulNP(a122,a1),1,-q11*q12^2);;
a12c:=MulNP(a12,a12);;
ar:=AddNP(a1122,a12c,1,-h);;

K:=[
y1f,a1f,
y2d,a2d,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g,
ra12,ra112,ra122,
ry12,ry112,ry122,
yr,ar
];;


Print("The ideal is: \n");

PrintNPList(K);

G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;


g12:=MulNP(g1,g2);;
gg1:=StrongNormalFormNP(g12,G);;
gg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
gg4:=StrongNormalFormNP(MulNP(gg2,gg2),G);;
gg6:=StrongNormalFormNP(MulNP(gg2,gg4),G);;
gg12:=StrongNormalFormNP(MulNP(gg6,gg6),G);;

aa1:=StrongNormalFormNP(a12,G);;
aa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
aa4:=StrongNormalFormNP(MulNP(aa2,aa2),G);;
aa6:=StrongNormalFormNP(MulNP(aa2,aa4),G);;
aa8:=StrongNormalFormNP(MulNP(aa2,aa6),G);;
aa10:=StrongNormalFormNP(MulNP(aa2,aa8),G);;
aa12:=StrongNormalFormNP(MulNP(aa2,aa10),G);;

yy1:=StrongNormalFormNP(y12,G);;
yy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
yy4:=StrongNormalFormNP(MulNP(yy2,yy2),G);;
yy6:=StrongNormalFormNP(MulNP(yy2,yy4),G);;
yy8:=StrongNormalFormNP(MulNP(yy2,yy6),G);;
yy10:=StrongNormalFormNP(MulNP(yy2,yy8),G);;
yy12:=StrongNormalFormNP(MulNP(yy2,yy10),G);;

r:=AddNP(AddNP(r12,aa12,1,-1),MulNP(gg12,yy12),1,-1);;

Print("The difference is \n");

PrintNP(StrongNormalFormNP(r,G));


###############################################################################################
###############################################################################################
###############################################################################################

Print("Case mu2 nonzero, q12=E(3)^2: \n");


q12:=E(3)^2;;

q21:=q*q12^-1;;



b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;

g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;

ra12:=AddNP(a12,AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12),1,-1);;
ra112:=AddNP(a112,AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12),1,-1);;
ra122:=AddNP(a122,AddNP(MulNP(a12,a2),MulNP(a2,a12),1,-q12*q22),1,-1);;

ry12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
ry112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
ry122:=AddNP(y122,AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22),1,-1);;

h:=(1+q+q^2)*q^4*q12;;

y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
y12c:=MulNP(y12,y12);;
yr:=AddNP(y1122,y12c,1,-h);;

a1122:=AddNP(MulNP(a1,a122),MulNP(a122,a1),1,-q11*q12^2);;
a12c:=MulNP(a12,a12);;
ar:=AddNP(a1122,a12c,1,-h);;

K:=[
y1f,a1f,
y2d,a2d,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g,
ra12,ra112,ra122,
ry12,ry112,ry122,
yr,ar
];;


Print("The ideal is: \n");

PrintNPList(K);

G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;


g12:=MulNP(g1,g2);;
gg1:=StrongNormalFormNP(g12,G);;
gg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
gg4:=StrongNormalFormNP(MulNP(gg2,gg2),G);;
gg6:=StrongNormalFormNP(MulNP(gg2,gg4),G);;
gg12:=StrongNormalFormNP(MulNP(gg6,gg6),G);;

aa1:=StrongNormalFormNP(a12,G);;
aa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
aa4:=StrongNormalFormNP(MulNP(aa2,aa2),G);;
aa6:=StrongNormalFormNP(MulNP(aa2,aa4),G);;
aa8:=StrongNormalFormNP(MulNP(aa2,aa6),G);;
aa10:=StrongNormalFormNP(MulNP(aa2,aa8),G);;
aa12:=StrongNormalFormNP(MulNP(aa2,aa10),G);;

yy1:=StrongNormalFormNP(y12,G);;
yy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
yy4:=StrongNormalFormNP(MulNP(yy2,yy2),G);;
yy6:=StrongNormalFormNP(MulNP(yy2,yy4),G);;
yy8:=StrongNormalFormNP(MulNP(yy2,yy6),G);;
yy10:=StrongNormalFormNP(MulNP(yy2,yy8),G);;
yy12:=StrongNormalFormNP(MulNP(yy2,yy10),G);;

r:=AddNP(AddNP(r12,aa12,1,-1),MulNP(gg12,yy12),1,-1);;

Print("The difference is \n");

PrintNP(StrongNormalFormNP(r,G));



