LogTo("/home/edwin/br(2,a)/cleft-br2a-M-N-6.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];


#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-q*F1;;
q21:=1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-1;;
q21:=q*F1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-q^2*F1;;
q21:=q^2*F1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 nonzero lambda2 zero, q21=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-q*F1;;
q21:=1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y26,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 nonzero lambda2 zero, q21=E(3)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-1;;
q21:=q*F1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y26,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 nonzero lambda2 zero, q21=E(3)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=-q^2*F1;;
q21:=q^2*F1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13d,x13,
y26,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=1\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=1;;
q21:=-q*F1;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);


#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^2\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^2*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^3\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^3*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^4\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^4*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

#########################################################
Print("\n \n Case lambda1 zero, lambda2 nonzero, q12=E(6)^5\n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(3);;
q11:=q*F1;;
q12:=E(6)^5*F1;;
q21:=-q/q12;;
q22:=-q^2*F1;;

y13:=[[[2,2,2]],[F1]];;
y26:=[[[1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x26:=[[[3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y26d:=AddNP(y26,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


K1:=[
b11,b12,b21,b22,
y13,x13,
y26d,x26,
y221,x221,
];;

Print("\n The ideal is \n");
PrintNPList(K1);
G1:=SGrobner(K1);

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;
xnb5:=StrongNormalFormNP(MulNP(xnb4,x112),G1);;
xnb6:=StrongNormalFormNP(MulNP(xnb5,x112),G1);;

ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;
ynb5:=StrongNormalFormNP(MulNP(ynb4,y112),G1);;
ynb6:=StrongNormalFormNP(MulNP(ynb5,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;
dnb5:=StrongNormalFormNP(MulNP(dnb4,d112),G1);;
dnb6:=StrongNormalFormNP(MulNP(dnb5,d112),G1);;

s112:=AddNP(ynb6,xnb6,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb6,s112,1,-1),G1);;

Print("\n The difference is \n");
PrintNP(r112);

quit;
