LogTo("/home/edwin/br(2,a)/cleft-br2a-M4-N12-E(12).log");;

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];


#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^0*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;

#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^1*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;
#########################################################
Print("\n \n Case lambda1 lambda2 nonzero, q21=E(3)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^2*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;

#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^0*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;

#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=E(3)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^1*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;

#########################################################
Print("\n \n Case lambda1 nonzero, lambda2 zero, q21=E(3)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q21:=E(3)^2*F1;;
q22:=q*F1;;
q12:=q22^-1/q21*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13d,x13,
y212,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

p112:=StrongNormalFormNP(MulNP(MulNP(d2,d2),MulNP(d12,d12)),G1);;   
h:=(4*E(12)^4+8*E(12)^7-4*E(12)^8+8*E(12)^11)*t1^2;;
q112:=StrongNormalFormNP(MulNP(MulNP(y2,y2),MulNP(y12,y12)),G1);;
k:=E(3)^2*q21*h;;
rr112:=StrongNormalFormNP(AddNP(r112,AddNP(p112,q112,1,-1),1,k),G1);;
Print("\n The difference is \n");;
PrintNP(rr112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=1\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^0*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^1*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^2\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^2*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^3\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^3*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^4\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^4*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^5\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^5*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^6\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^6*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^7\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^7*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^8\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^8*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^9\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^9*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;


#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^10\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^10*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

#########################################################
Print("\n \n Case lambda1 zero lambda2 nonzero, q12=E(12)^11\n");;

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

F1:=1;;
q:=E(12)*F1;;
z:=q^4;;
q11:=z*F1;;
q12:=E(12)^11*F1;;
q22:=q*F1;;
q21:=q22^-1/q12*F1;;

y13:=[[[2,2,2]],[F1]];;
y212:=[[[1,1,1,1,1,1,1,1,1,1,1,1]],[F1]];;
x13:=[[[4,4,4]],[F1]];;
x212:=[[[3,3,3,3,3,3,3,3,3,3,3,3]],[F1]];;

y21:=AddNP(MulNP(y2,y1),MulNP(y1,y2),F1,-q21);;
x21:=AddNP(MulNP(x2,x1),MulNP(x1,x2),F1,-q21);;

y221:=AddNP(MulNP(y2,y21),MulNP(y21,y2),F1,-q22*q21);;
x221:=AddNP(MulNP(x2,x21),MulNP(x21,x2),F1,-q22*q21);;

y13d:=AddNP(y13,[[[]],[F1]],1,-t1);;
y212d:=AddNP(y212,[[[]],[F1]],1,-t2);;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

K1:=[
b11,b12,b21,b22,
y13,x13,
y212d,x212,
y221,x221,
];;

Print("\n The ideal is \n");;
PrintNPList(K1);;
G1:=SGrobner(K1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),F1,-q12);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),F1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),F1,-q11*q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),F1,-q11*q12);;

xnb2:=StrongNormalFormNP(MulNP(x112,x112),G1);;
xnb3:=StrongNormalFormNP(MulNP(xnb2,x112),G1);;
xnb4:=StrongNormalFormNP(MulNP(xnb3,x112),G1);;


ynb2:=StrongNormalFormNP(MulNP(y112,y112),G1);;
ynb3:=StrongNormalFormNP(MulNP(ynb2,y112),G1);;
ynb4:=StrongNormalFormNP(MulNP(ynb3,y112),G1);;

d112:=AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q11*q12);;
dnb2:=StrongNormalFormNP(MulNP(d112,d112),G1);;
dnb3:=StrongNormalFormNP(MulNP(dnb2,d112),G1);;
dnb4:=StrongNormalFormNP(MulNP(dnb3,d112),G1);;

s112:=AddNP(ynb4,xnb4,1,1);;
r112:=StrongNormalFormNP(AddNP(dnb4,s112,1,-1),G1);;

Print("\n The difference is \n");;
PrintNP(r112);;

quit;
