LogTo("/home/edwin/br(2,a)/ufo 8/cleft-ufo8a.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];

F1:=1;;
q:=E(12)*F1;;
qc:=q^2*F1;;
q11:=-q^2*F1;;
q22:=-q^2*F1;;

########################################################################################################################################
Print("Case lambda2 nonzero, q12=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q12:=1;;
q21:=q*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
y2c:=MulNP(y2,MulNP(y2,y2));;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;

x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));


Print("The ideal is: \n");

K1:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22,
xrel, yrel
];;

PrintNPList(K1);
G1:=SGrobner(K1);;


x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

#######################################################################################################################################
Print("\n \n Case lambda2 nonzero, q12=E(3): \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q12:=E(3)*F1;;
q21:=q*q12^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));;

y1c:=MulNP(y1,MulNP(y1,y1));;
y2c:=MulNP(y2,MulNP(y2,y2));;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));;

Print("The ideal is: \n");

K1:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22,
xrel, yrel
];;


PrintNPList(K1);
G1:=SGrobner(K1);;

x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

#########################################################################################################################
Print("\n \ n Case lambda2 nonzero, q12=E(3)^2: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q12:=E(3)^2*F1;;
q21:=q*q12^-1*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));;

y1c:=MulNP(y1,MulNP(y1,y1));;
y2c:=MulNP(y2,MulNP(y2,y2));;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));;

Print("The ideal is: \n");

K1:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22,
xrel, yrel
];;


PrintNPList(K1);
G1:=SGrobner(K1);;

x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################
Print("\n \n Case lambda1 nonzero, q21=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=1*F1;;
q12:=q*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));;

y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,MulNP(y2,y2));;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));;

Print("The ideal is: \n");
K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
xrel, yrel
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################
Print("\n \n Case lambda1 nonzero, q21=E(3): \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(3)*F1;;
q12:=q*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));;

y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,MulNP(y2,y2));;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));;

Print("The ideal is: \n");
K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
xrel, yrel
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################
Print("\n \n Case lambda1 nonzero, q21=E(3)^2: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(3)^2*F1;;
q12:=q*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1c:=MulNP(x1,MulNP(x1,x1));;
x2c:=MulNP(x2,MulNP(x2,x2));;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x12c:=MulNP(x12,x12);;
x122:=AddNP(MulNP(x12,x2),MulNP(x2,x12),1,-q12*q22);;
x1122:=AddNP(MulNP(x1,x122),MulNP(x122,x1),1,-q11*q12^2);;
xrel:=AddNP(x1122,x12c, 1, (-1-q-qc)*(qc^2*q12));;

y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,MulNP(y2,y2));;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y12c:=MulNP(y12,y12);;
y122:=AddNP(MulNP(y12,y2),MulNP(y2,y12),1,-q12*q22);;
y1122:=AddNP(MulNP(y1,y122),MulNP(y122,y1),1,-q11*q12^2);;
yrel:=AddNP(y1122,y12c, 1, (-1-q-qc)*(qc^2*q12));;

Print("The ideal is: \n");
K1:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
xrel, yrel
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x12cc:=StrongNormalFormNP(MulNP(x12c,x12c),G1);;
x12ccc:=StrongNormalFormNP(MulNP(x12cc,x12cc),G1);;
x12t:=StrongNormalFormNP(MulNP(x12ccc,x12cc),G1);;

y12cc:=StrongNormalFormNP(MulNP(y12c,y12c),G1);;
y12ccc:=StrongNormalFormNP(MulNP(y12cc,y12cc),G1);;
y12t:=StrongNormalFormNP(MulNP(y12ccc,y12cc),G1);;


d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d122:=StrongNormalFormNP(MulNP(d12,d12),G1);;
d123:=StrongNormalFormNP(MulNP(d122,d12),G1);;
d124:=StrongNormalFormNP(MulNP(d123,d12),G1);;
d125:=StrongNormalFormNP(MulNP(d124,d12),G1);;
d126:=StrongNormalFormNP(MulNP(d125,d12),G1);;
d127:=StrongNormalFormNP(MulNP(d126,d12),G1);;
d128:=StrongNormalFormNP(MulNP(d127,d12),G1);;
d129:=StrongNormalFormNP(MulNP(d128,d12),G1);;
d1210:=StrongNormalFormNP(MulNP(d129,d12),G1);;
d1211:=StrongNormalFormNP(MulNP(d1210,d12),G1);;
d12t:=StrongNormalFormNP(MulNP(d1211,d12),G1);;


s:=AddNP(y12t,x12t,1,1);;
z:=StrongNormalFormNP(AddNP(d12t,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

quit;






