LogTo("/home/agustin/Dropbox/math/in-progress/ufo/gap/web/cleft-ufo8b-2.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y12","yb","y112","y1","x2","x12","xb","x112","x1");

q:=E(12);;

q11:=-q^2;;

q22:=-1;;


y1:=[[[5]],[1]];;
y112:=[[[4]],[1]];;
yb:=[[[3]],[1]];;
y12:=[[[2]],[1]];;
y2:=[[[1]],[1]];;


x1:=[[[10]],[1]];;
x112:=[[[9]],[1]];;
xb:=[[[8]],[1]];;
x12:=[[[7]],[1]];;
x2:=[[[6]],[1]];;


Print("Case lambda2 nonzero, q12=1: \n");


q12:=1;;
q21:=q^3*q12^-1;;


c2:=Indeterminate(Rationals,"c2");;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

dy12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
dy112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
dyb:=AddNP(yb,AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),1,-1);;

dx12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12),1,-1);;
dx112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12),1,-1);;
dxb:=AddNP(xb,AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),1,-1);;

x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
xr:=AddNP(MulNP(xb,x12),MulNP(x12,xb),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22,
dy12,dy112,dyb,
dx12,dx112,dxb,
yr,xr
];;

Print("The ideal is \n");

PrintNPList(K);

G:=SGrobner(K);;


l1:=AddNP(y1,x1,1,1);;
l2:=AddNP(y2,x2,1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

sx2:=StrongNormalFormNP(MulNP(x12,x12),G);;
sx4:=StrongNormalFormNP(MulNP(sx2,sx2),G);;
sx8:=StrongNormalFormNP(MulNP(sx4,sx4),G);;
sx12:=StrongNormalFormNP(MulNP(sx4,sx8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sy12,1,-1),sx12,1,-1),G);;

PrintNP(ga1);

######################################
###########################################################
######################################

Print("Case lambda2 nonzero, q12=-1: \n");

q12:=1;;
q21:=q^3*q12^-1;;


c2:=Indeterminate(Rationals,"c2");;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

dy12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
dy112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
dyb:=AddNP(yb,AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),1,-1);;

dx12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12),1,-1);;
dx112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12),1,-1);;
dxb:=AddNP(xb,AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),1,-1);;

x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
xr:=AddNP(MulNP(xb,x12),MulNP(x12,xb),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1c,x1c,x2c,y2d,
b11,b12,b21,b22,
dy12,dy112,dyb,
dx12,dx112,dxb,
xr,yr
];;

Print("The ideal is \n");

PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(y1,x1,1,1);;
l2:=AddNP(y2,x2,1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

sx2:=StrongNormalFormNP(MulNP(x12,x12),G);;
sx4:=StrongNormalFormNP(MulNP(sx2,sx2),G);;
sx8:=StrongNormalFormNP(MulNP(sx4,sx4),G);;
sx12:=StrongNormalFormNP(MulNP(sx4,sx8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sy12,1,-1),sx12,1,-1),G);;

PrintNP(ga1);


######################################
###########################################################
######################################


Print("Case lambda1 nonzero, q21=1: \n");

q21:=1;;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

dy12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
dy112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
dyb:=AddNP(yb,AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),1,-1);;

dx12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12),1,-1);;
dx112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12),1,-1);;
dxb:=AddNP(xb,AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),1,-1);;

x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;


x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
xr:=AddNP(MulNP(xb,x12),MulNP(x12,xb),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
dy12,dy112,dyb,
dx12,dx112,dxb,
xr,yr
];;

Print("The ideal is \n");

PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(y1,x1,1,1);;
l2:=AddNP(y2,x2,1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

sx2:=StrongNormalFormNP(MulNP(x12,x12),G);;
sx4:=StrongNormalFormNP(MulNP(sx2,sx2),G);;
sx8:=StrongNormalFormNP(MulNP(sx4,sx4),G);;
sx12:=StrongNormalFormNP(MulNP(sx4,sx8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sy12,1,-1),sx12,1,-1),G);;

PrintNP(ga1);


######################################
###########################################################
######################################


Print("Case lambda1 nonzero, q21=E(3): \n");

q21:=E(3);;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

dy12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
dy112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
dyb:=AddNP(yb,AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),1,-1);;

dx12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12),1,-1);;
dx112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12),1,-1);;
dxb:=AddNP(xb,AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),1,-1);;

x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;


x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
xr:=AddNP(MulNP(xb,x12),MulNP(x12,xb),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
dy12,dy112,dyb,
dx12,dx112,dxb,
xr,yr
];;

Print("The ideal is \n");

PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(y1,x1,1,1);;
l2:=AddNP(y2,x2,1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

sx2:=StrongNormalFormNP(MulNP(x12,x12),G);;
sx4:=StrongNormalFormNP(MulNP(sx2,sx2),G);;
sx8:=StrongNormalFormNP(MulNP(sx4,sx4),G);;
sx12:=StrongNormalFormNP(MulNP(sx4,sx8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sy12,1,-1),sx12,1,-1),G);;

PrintNP(ga1);


######################################
###########################################################
######################################


Print("Case lambda1 nonzero, q21=E(3)^2: \n");

q21:=E(3)^2;;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

dy12:=AddNP(y12,AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12),1,-1);;
dy112:=AddNP(y112,AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12),1,-1);;
dyb:=AddNP(yb,AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),1,-1);;

dx12:=AddNP(x12,AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12),1,-1);;
dx112:=AddNP(x112,AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q11*q12),1,-1);;
dxb:=AddNP(xb,AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),1,-1);;

x1c:=MulNP(x1,MulNP(x1,x1));;
y1c:=MulNP(y1,MulNP(y1,y1));;
y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;


x2c:=MulNP(x2,x2);;
y2c:=MulNP(y2,y2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
xr:=AddNP(MulNP(xb,x12),MulNP(x12,xb),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1d,x1c,x2c,y2c,
b11,b12,b21,b22,
dy12,dy112,dyb,
dx12,dx112,dxb,
xr,yr
];;

Print("The ideal is \n");

PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(y1,x1,1,1);;
l2:=AddNP(y2,x2,1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;

r2:=StrongNormalFormNP(MulNP(r1,r1),G);;

r4:=StrongNormalFormNP(MulNP(r2,r2),G);;

r6:=StrongNormalFormNP(MulNP(r2,r4),G);;

r8:=StrongNormalFormNP(MulNP(r2,r6),G);;

r10:=StrongNormalFormNP(MulNP(r2,r8),G);;

r12:=StrongNormalFormNP(MulNP(r2,r10),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

sx2:=StrongNormalFormNP(MulNP(x12,x12),G);;
sx4:=StrongNormalFormNP(MulNP(sx2,sx2),G);;
sx8:=StrongNormalFormNP(MulNP(sx4,sx4),G);;
sx12:=StrongNormalFormNP(MulNP(sx4,sx8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sy12,1,-1),sx12,1,-1),G);;

PrintNP(ga1);


