LogTo("/home/edwin/br(2,a)/ufo 8/cleft-ufo8c.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("y2","y1","x2","x1");

y2:=[[[1]],[1]];
y1:=[[[2]],[1]];
x2:=[[[3]],[1]];
x1:=[[[4]],[1]];

F1:=1;;
q:=E(12)*F1;;
q11:=-q^-1*F1;;
q22:=-1*F1;;

Print("Case lambda2 nonzero, q12=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q12:=1*F1;;
q21:=-q^3*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
y1t,x1t,x2c,y2d,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

#######################################################################################################################################
Print("\n \n Case lambda2 nonzero, q12=-1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q12:=-1*F1;;
q21:=q^3*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-t2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
y1t,x1t,x2c,y2d,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);
######################################################################################################################################


Print("\n \n Case lambda1 nonzero, q21=1: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=1*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12): \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);


########################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^2: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^2*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;


PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);
########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^3: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^3*F1;;
q12:=-q^3*q21^-1*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;




x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;


PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^4: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^4*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^5: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^5*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^6: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^6*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;


x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);
########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^7: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^7*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^8: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^8*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^9: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^9*F1;;
q12:=-q^3*q21^-1*F1;;

b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;


Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^10: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^10*F1;;
q12:=-q^3*q21^-1*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);
########################################################################################################################################

Print("\n \n Case lambda1 nonzero, q21=E(12)^11: \n");

t1:=Indeterminate(Rationals,"t1");;
t2:=Indeterminate(Rationals,"t2");;

q21:=E(12)^11*F1;;
q12:=-q^3*q21^-1*F1;;


b11:=AddNP(MulNP(x1,y1),MulNP(y1,x1),1,-q11);;
b12:=AddNP(MulNP(x1,y2),MulNP(y2,x1),1,-q12);;
b21:=AddNP(MulNP(x2,y1),MulNP(y1,x2),1,-q21);;
b22:=AddNP(MulNP(x2,y2),MulNP(y2,x2),1,-q22);;

x1f:=MulNP(x1,MulNP(x1,MulNP(x1,x1)));;
x1t:=MulNP(x1f,MulNP(x1f,x1f));;
x2c:=MulNP(x2,x2);;
x12:=AddNP(MulNP(x1,x2),MulNP(x2,x1),1,-q12);;
x112:=AddNP(MulNP(x1,x12),MulNP(x12,x1),1,-q12*q11);;
x1112:=AddNP(MulNP(x1,x112),MulNP(x112,x1),1,-q11^2*q12);;
x11112:=AddNP(MulNP(x1,x1112),MulNP(x1112,x1),1,-q11^3*q12);;

y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;
y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-t1);;
y2c:=MulNP(y2,y2);;
y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q12*q11);;
y1112:=AddNP(MulNP(y1,y112),MulNP(y112,y1),1,-q11^2*q12);;
y11112:=AddNP(MulNP(y1,y1112),MulNP(y1112,y1),1,-q11^3*q12);;

Print("The ideal is: \n");
K1:=[
x1t,y1d,x2c,y2c,
b11,b12,b21,b22,
x11112,y11112
];;

PrintNPList(K1);
G1:=SGrobner(K1);;

x11212:=StrongNormalFormNP(AddNP(MulNP(x112,x12),MulNP(x12,x112),1,-q11^2*q12^2*q21*q22),G1);;
y11212:=StrongNormalFormNP(AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22),G1);;

d1:=AddNP(y1,x1,1,1);;
d2:=AddNP(y2,x2,1,1);;
d12:=StrongNormalFormNP(AddNP(MulNP(d1,d2),MulNP(d2,d1),1,-q12),G1);;
d112:=StrongNormalFormNP(AddNP(MulNP(d1,d12),MulNP(d12,d1),1,-q12*q11),G1);;
d11212:=StrongNormalFormNP(AddNP(MulNP(d112,d12),MulNP(d12,d112),1,-q11^2*q12^2*q21*q22),G1);;

s:=AddNP(y11212,x11212,1,1);;
z:=StrongNormalFormNP(AddNP(d11212,s,1,-1),G1);;
Print("The difference is \n");
PrintNP(z);

quit;






