#LogTo("/home/agustin/Dropbox/Matemática/in-progress/ufo/gap/lift-ufo8b-1.log");

LogTo("/home/aigarcia/gap4r8/bin/ufo/lift-ufo8b-2.log");

LoadPackage("GBNP");

GBNP.ConfigPrint("a2","a1","y2","y1","g2","g1");


q:=E(12);;

q11:=-q^2;;

q22:=-1;;



a1:=[[[2]],[1]];;
a2:=[[[1]],[1]];;


y1:=[[[4]],[1]];;
y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;
g2:=[[[5]],[1]];;


Print("Case lambda2 nonzero, q12=1: \n");


q12:=1;;
q21:=q^3*q12^-1;;


c2:=Indeterminate(Rationals,"c2");;

c2:=1;;

b11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;
b12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;
b21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;
b22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;

v11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),1,-1);;
v12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),1,-1);;
v21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),1,-1);;
v22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),1,-1);;

w11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;
w12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;
w21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;
w22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


gg:=AddNP(MulNP(g2,g1),MulNP(g1,g2),1,-1);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;
ab:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
yb:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;

a1c:=MulNP(a1,MulNP(a1,a1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

a2c:=MulNP(a2,a2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;
a2d:=AddNP(AddNP(a2c,[ [ [] ],[1]  ],1,-c2),MulNP(g2,g2),1,c2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
ar:=AddNP(MulNP(ab,a12),MulNP(a12,ab),1,-q11^3*q12^3*q21^2*q22^2);;


adef:=MulNP(MulNP(g2,g2),MulNP(a112,MulNP(a1,a1)));;
cdef:=2*q12*c2*(1+q^3);;

ad:=AddNP(ar,adef,1,cdef);;

K:=[
y1c,a1c,a2d,y2d,
b11,b12,b21,b22,
v11,v12,v21,v22,
w11,w12,w21,w22,
gg,
yr,
ad
];;

Print("The ideal is \n");

PrintNPList(K);

Print("Computing Grobner basis... \n");

G:=SGrobner(K);;

Print("Done. \n");


Print("Computing the coaction... \n");


l1:=AddNP(a1,MulNP(g1,y1),1,1);;
l2:=AddNP(a2,MulNP(g2,y2),1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

r1:=StrongNormalFormNP(l12,G);;
r2:=StrongNormalFormNP(MulNP(r1,r1),G);;
r4:=StrongNormalFormNP(MulNP(r2,r2),G);;
r6:=StrongNormalFormNP(MulNP(r2,r4),G);;
r7:=StrongNormalFormNP(MulNP(r1,r6),G);;
r8:=StrongNormalFormNP(MulNP(r1,r7),G);;
r9:=StrongNormalFormNP(MulNP(r1,r8),G);;
r10:=StrongNormalFormNP(MulNP(r1,r9),G);;
r11:=StrongNormalFormNP(MulNP(r1,r10),G);;
r12:=StrongNormalFormNP(MulNP(r1,r11),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

g12:=MulNP(g1,g2);;
sg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
sg4:=StrongNormalFormNP(MulNP(sg2,sg2),G);;
sg8:=StrongNormalFormNP(MulNP(sg4,sg4),G);;
sg12:=StrongNormalFormNP(MulNP(sg4,sg8),G);;

sa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
sa4:=StrongNormalFormNP(MulNP(sa2,sa2),G);;
sa8:=StrongNormalFormNP(MulNP(sa4,sa4),G);;
sa12:=StrongNormalFormNP(MulNP(sa4,sa8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sa12,1,-1),MulNP(sg12,sy12),1,-1),G);;

PrintNP(ga1);

########################################################################
########################################################################
########################################################################
########################################################################



Print("Case lambda2 nonzero, q12=-1: \n");


q12:=-1;;
q21:=q^3*q12^-1;;



c2:=Indeterminate(Rationals,"c2");;

c2:=1;;

b11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;
b12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;
b21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;
b22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;

v11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),1,-1);;
v12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),1,-1);;
v21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),1,-1);;
v22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),1,-1);;

w11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;
w12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;
w21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;
w22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


gg:=AddNP(MulNP(g2,g1),MulNP(g1,g2),1,-1);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;
ab:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
yb:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;

a1c:=MulNP(a1,MulNP(a1,a1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

a2c:=MulNP(a2,a2);;
y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;
a2d:=AddNP(AddNP(a2c,[ [ [] ],[1]  ],1,-c2),MulNP(g2,g2),1,c2);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
ar:=AddNP(MulNP(ab,a12),MulNP(a12,ab),1,-q11^3*q12^3*q21^2*q22^2);;


adef:=MulNP(MulNP(g2,g2),MulNP(a112,MulNP(a1,a1)));;
cdef:=2*q12*c2*(1+q^3);;

ad:=AddNP(ar,adef,1,cdef);;

K:=[
y1c,a1c,a2d,y2d,
b11,b12,b21,b22,
v11,v12,v21,v22,
w11,w12,w21,w22,
gg,
yr,
ad
];;


Print("The ideal is \n");

PrintNPList(K);


Print("Computing Grobner basis... \n");

G:=SGrobner(K);;

Print("Done. \n");


Print("Computing the coaction... \n");



l1:=AddNP(a1,MulNP(g1,y1),1,1);;
l2:=AddNP(a2,MulNP(g2,y2),1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;
r2:=StrongNormalFormNP(MulNP(r1,r1),G);;
r4:=StrongNormalFormNP(MulNP(r2,r2),G);;
r6:=StrongNormalFormNP(MulNP(r2,r4),G);;
r7:=StrongNormalFormNP(MulNP(r1,r6),G);;
r8:=StrongNormalFormNP(MulNP(r1,r7),G);;
r9:=StrongNormalFormNP(MulNP(r1,r8),G);;
r10:=StrongNormalFormNP(MulNP(r1,r9),G);;
r11:=StrongNormalFormNP(MulNP(r1,r10),G);;
r12:=StrongNormalFormNP(MulNP(r1,r11),G);;


sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

g12:=MulNP(g1,g2);;
sg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
sg4:=StrongNormalFormNP(MulNP(sg2,sg2),G);;
sg8:=StrongNormalFormNP(MulNP(sg4,sg4),G);;
sg12:=StrongNormalFormNP(MulNP(sg4,sg8),G);;

sa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
sa4:=StrongNormalFormNP(MulNP(sa2,sa2),G);;
sa8:=StrongNormalFormNP(MulNP(sa4,sa4),G);;
sa12:=StrongNormalFormNP(MulNP(sa4,sa8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sa12,1,-1),MulNP(sg12,sy12),1,-1),G);;

PrintNP(ga1);

########################################################################
########################################################################
########################################################################
########################################################################


Print("Case lambda1 nonzero, q21=1: \n");


q21:=1;;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;

c1:=1;;

b11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;
b12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;
b21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;
b22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;

v11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),1,-1);;
v12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),1,-1);;
v21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),1,-1);;
v22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),1,-1);;

w11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;
w12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;
w21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;
w22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


gg:=AddNP(MulNP(g2,g1),MulNP(g1,g2),1,-1);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;
ab:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
yb:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;

a1c:=MulNP(a1,MulNP(a1,a1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

a2c:=MulNP(a2,a2);;
y2c:=MulNP(y2,y2);;

y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;
a1d:=AddNP(AddNP(a1c,[ [ [] ],[1]  ],1,-c1),MulNP(g1,MulNP(g1,g1)),1,c1);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
ar:=AddNP(MulNP(ab,a12),MulNP(a12,ab),1,-q11^3*q12^3*q21^2*q22^2);;

K:=[
y1d,a1d,a2c,y2c,
b11,b12,b21,b22,
v11,v12,v21,v22,
w11,w12,w21,w22,
gg,
yr,
ar
];;

Print("The ideal is \n");

PrintNPList(K);


Print("Computing Grobner basis... \n");

G:=SGrobner(K);;

Print("Done. \n");


Print("Computing the coaction... \n");



l1:=AddNP(a1,MulNP(g1,y1),1,1);;
l2:=AddNP(a2,MulNP(g2,y2),1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

r1:=StrongNormalFormNP(l12,G);;
r2:=StrongNormalFormNP(MulNP(r1,r1),G);;
r4:=StrongNormalFormNP(MulNP(r2,r2),G);;
r6:=StrongNormalFormNP(MulNP(r2,r4),G);;
r7:=StrongNormalFormNP(MulNP(r1,r6),G);;
r8:=StrongNormalFormNP(MulNP(r1,r7),G);;
r9:=StrongNormalFormNP(MulNP(r1,r8),G);;
r10:=StrongNormalFormNP(MulNP(r1,r9),G);;
r11:=StrongNormalFormNP(MulNP(r1,r10),G);;
r12:=StrongNormalFormNP(MulNP(r1,r11),G);;

sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

g12:=MulNP(g1,g2);;
sg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
sg4:=StrongNormalFormNP(MulNP(sg2,sg2),G);;
sg8:=StrongNormalFormNP(MulNP(sg4,sg4),G);;
sg12:=StrongNormalFormNP(MulNP(sg4,sg8),G);;

sa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
sa4:=StrongNormalFormNP(MulNP(sa2,sa2),G);;
sa8:=StrongNormalFormNP(MulNP(sa4,sa4),G);;
sa12:=StrongNormalFormNP(MulNP(sa4,sa8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sa12,1,-1),MulNP(sg12,sy12),1,-1),G);;

PrintNP(ga1);

########################################################################
########################################################################
########################################################################
########################################################################


Print("Case lambda1 nonzero, q21=E(3): \n");


q21:=E(3);;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;

c1:=1;;

b11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;
b12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;
b21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;
b22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;

v11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),1,-1);;
v12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),1,-1);;
v21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),1,-1);;
v22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),1,-1);;

w11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;
w12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;
w21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;
w22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


gg:=AddNP(MulNP(g2,g1),MulNP(g1,g2),1,-1);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;
ab:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
yb:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;

a1c:=MulNP(a1,MulNP(a1,a1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

a2c:=MulNP(a2,a2);;
y2c:=MulNP(y2,y2);;


y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;
a1d:=AddNP(AddNP(a1c,[ [ [] ],[1]  ],1,-c1),MulNP(g1,MulNP(g1,g1)),1,c1);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
ar:=AddNP(MulNP(ab,a12),MulNP(a12,ab),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1d,a1d,a2c,y2c,
b11,b12,b21,b22,
v11,v12,v21,v22,
w11,w12,w21,w22,
gg,
yr,ar
];;

Print("The ideal is \n");

PrintNPList(K);


Print("Computing Grobner basis... \n");

G:=SGrobner(K);;

Print("Done. \n");


Print("Computing the coaction... \n");



l1:=AddNP(a1,MulNP(g1,y1),1,1);;
l2:=AddNP(a2,MulNP(g2,y2),1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;


r1:=StrongNormalFormNP(l12,G);;
r2:=StrongNormalFormNP(MulNP(r1,r1),G);;
r4:=StrongNormalFormNP(MulNP(r2,r2),G);;
r6:=StrongNormalFormNP(MulNP(r2,r4),G);;
r7:=StrongNormalFormNP(MulNP(r1,r6),G);;
r8:=StrongNormalFormNP(MulNP(r1,r7),G);;
r9:=StrongNormalFormNP(MulNP(r1,r8),G);;
r10:=StrongNormalFormNP(MulNP(r1,r9),G);;
r11:=StrongNormalFormNP(MulNP(r1,r10),G);;
r12:=StrongNormalFormNP(MulNP(r1,r11),G);;


sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

g12:=MulNP(g1,g2);;
sg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
sg4:=StrongNormalFormNP(MulNP(sg2,sg2),G);;
sg8:=StrongNormalFormNP(MulNP(sg4,sg4),G);;
sg12:=StrongNormalFormNP(MulNP(sg4,sg8),G);;

sa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
sa4:=StrongNormalFormNP(MulNP(sa2,sa2),G);;
sa8:=StrongNormalFormNP(MulNP(sa4,sa4),G);;
sa12:=StrongNormalFormNP(MulNP(sa4,sa8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sa12,1,-1),MulNP(sg12,sy12),1,-1),G);;

PrintNP(ga1);

########################################################################
########################################################################
########################################################################
########################################################################





Print("Case lambda1 nonzero, q21=E(3)^2: \n");


q21:=E(3)^2;;
q12:=q^3*q21^-1;;


c1:=Indeterminate(Rationals,"c1");;

c1:=1;;

b11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;
b12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;
b21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;
b22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;

v11:=AddNP(MulNP(g1,y1),MulNP(y1,g1),1,-1);;
v12:=AddNP(MulNP(g1,y2),MulNP(y2,g1),1,-1);;
v21:=AddNP(MulNP(g2,y1),MulNP(y1,g2),1,-1);;
v22:=AddNP(MulNP(g2,y2),MulNP(y2,g2),1,-1);;

w11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;
w12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;
w21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;
w22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


gg:=AddNP(MulNP(g2,g1),MulNP(g1,g2),1,-1);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;
a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;
ab:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;
y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;
yb:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;

a1c:=MulNP(a1,MulNP(a1,a1));;
y1c:=MulNP(y1,MulNP(y1,y1));;

a2c:=MulNP(a2,a2);;
y2c:=MulNP(y2,y2);;


y1d:=AddNP(y1c,[ [ [] ],[1]  ],1,-c1);;
a1d:=AddNP(AddNP(a1c,[ [ [] ],[1]  ],1,-c1),MulNP(g1,MulNP(g1,g1)),1,c1);;

yr:=AddNP(MulNP(yb,y12),MulNP(y12,yb),1,-q11^3*q12^3*q21^2*q22^2);;
ar:=AddNP(MulNP(ab,a12),MulNP(a12,ab),1,-q11^3*q12^3*q21^2*q22^2);;


K:=[
y1d,a1d,a2c,y2c,
b11,b12,b21,b22,
v11,v12,v21,v22,
w11,w12,w21,w22,
gg,
yr,ar
];;

Print("The ideal is \n");

PrintNPList(K);


Print("Computing Grobner basis... \n");

G:=SGrobner(K);;

Print("Done. \n");


Print("Computing the coaction... \n");




l1:=AddNP(a1,MulNP(g1,y1),1,1);;
l2:=AddNP(a2,MulNP(g2,y2),1,1);;
l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;



r1:=StrongNormalFormNP(l12,G);;
r2:=StrongNormalFormNP(MulNP(r1,r1),G);;
r4:=StrongNormalFormNP(MulNP(r2,r2),G);;
r6:=StrongNormalFormNP(MulNP(r2,r4),G);;
r7:=StrongNormalFormNP(MulNP(r1,r6),G);;
r8:=StrongNormalFormNP(MulNP(r1,r7),G);;
r9:=StrongNormalFormNP(MulNP(r1,r8),G);;
r10:=StrongNormalFormNP(MulNP(r1,r9),G);;
r11:=StrongNormalFormNP(MulNP(r1,r10),G);;
r12:=StrongNormalFormNP(MulNP(r1,r11),G);;


sy2:=StrongNormalFormNP(MulNP(y12,y12),G);;
sy4:=StrongNormalFormNP(MulNP(sy2,sy2),G);;
sy8:=StrongNormalFormNP(MulNP(sy4,sy4),G);;
sy12:=StrongNormalFormNP(MulNP(sy4,sy8),G);;

g12:=MulNP(g1,g2);;
sg2:=StrongNormalFormNP(MulNP(g12,g12),G);;
sg4:=StrongNormalFormNP(MulNP(sg2,sg2),G);;
sg8:=StrongNormalFormNP(MulNP(sg4,sg4),G);;
sg12:=StrongNormalFormNP(MulNP(sg4,sg8),G);;

sa2:=StrongNormalFormNP(MulNP(a12,a12),G);;
sa4:=StrongNormalFormNP(MulNP(sa2,sa2),G);;
sa8:=StrongNormalFormNP(MulNP(sa4,sa4),G);;
sa12:=StrongNormalFormNP(MulNP(sa4,sa8),G);;

Print("The difference of the coaction is \n");

ga1:=StrongNormalFormNP(AddNP(AddNP(r12,sa12,1,-1),MulNP(sg12,sy12),1,-1),G);;

PrintNP(ga1);


########################################################################
########################################################################
########################################################################
########################################################################




