
LoadPackage("GBNP");


GBNP.ConfigPrint("a2","a1","y2","y1","g2","g1");


q:=E(12);;

u:=[ [ [],  ],[1]  ];;


q11:=-q^-1;;

q22:=-1;;


c1:=Indeterminate(Rationals,"c1");;
c2:=Indeterminate(Rationals,"c2");;



Print("Case lambda2 nonzero, q12=1: \n");



q12:=1;;

q21:=-q^3;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

a1f:=MulNP(a1,MulNP(a1,MulNP(a1,a1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;

a1t:=MulNP(a1f,MulNP(a1f,a1f));;

y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;



K:=[
y1t,a1t,
y2d,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#########################################################################################################################################

Print("Case lambda2 nonzero, q12=-1: \n");



q12:=-1;;

q21:=q^3;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

a1f:=MulNP(a1,MulNP(a1,MulNP(a1,a1)));;
y1t:=MulNP(y1f,MulNP(y1f,y1f));;

a1t:=MulNP(a1f,MulNP(a1f,a1f));;

y2c:=MulNP(y2,y2);;
y2d:=AddNP(y2c,[ [ [] ],[1]  ],1,-c2);;



K:=[
y1t,a1t,
y2d,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=1: \n");



q21:=1;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12): \n");



q21:=E(12);;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^2: \n");



q21:=E(12)^2;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^3: \n");



q21:=E(12)^3;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^4: \n");



q21:=E(12)^4;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^5: \n");



q21:=E(12)^5;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^6: \n");



q21:=E(12)^6;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^7: \n");



q21:=E(12)^7;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^8: \n");



q21:=E(12)^8;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^9: \n");



q21:=E(12)^9;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^10: \n");



q21:=E(12)^10;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);

#####################################################################################################################################

Print("Case lambda1 nonzero, q21=E(12)^11: \n");



q21:=E(12)^11;;

q12:=-q^3*q21^-1;;


a1:=[[[2]],[1]];;

a2:=[[[1]],[1]];;

y1:=[[[4]],[1]];;

y2:=[[[3]],[1]];;

g1:=[[[6]],[1]];;

g2:=[[[5]],[1]];;


b11:=AddNP(MulNP(a1,y1),MulNP(y1,a1),1,-1);;

b12:=AddNP(MulNP(a1,y2),MulNP(y2,a1),1,-1);;

b21:=AddNP(MulNP(a2,y1),MulNP(y1,a2),1,-1);;

b22:=AddNP(MulNP(a2,y2),MulNP(y2,a2),1,-1);;


u11:=AddNP(MulNP(g1,a1),MulNP(a1,g1),1,-q11);;

u12:=AddNP(MulNP(g1,a2),MulNP(a2,g1),1,-q12);;

u21:=AddNP(MulNP(g2,a1),MulNP(a1,g2),1,-q21);;

u22:=AddNP(MulNP(g2,a2),MulNP(a2,g2),1,-q22);;


v11:=AddNP(MulNP(y1,g1),MulNP(g1,y1),1,-1);;

v12:=AddNP(MulNP(y1,g2),MulNP(g2,y1),1,-1);;

v21:=AddNP(MulNP(y2,g1),MulNP(g1,y2),1,-1);;

v22:=AddNP(MulNP(y2,g2),MulNP(g2,y2),1,-1);;


g:=AddNP(MulNP(g1,g2),MulNP(g2,g1),1,-1);;


y1f:=MulNP(y1,MulNP(y1,MulNP(y1,y1)));;

y1t:=MulNP(y1f,MulNP(y1f,y1f));;

y1d:=AddNP(y1t,[ [ [] ],[1]  ],1,-c1);;
a2c:=MulNP(a2,a2);;

y2c:=MulNP(y2,y2);;
K:=[
y1d,a2c,
y2c,
b11,b12,b21,b22,
u11,u12,u21,u22,
v11,v12,v21,v22,
g
];;


Print("The ideal is: \n");


PrintNPList(K);


G:=SGrobner(K);;


l1:=AddNP(a1,MulNP(g1,y1),1,1);;

l2:=AddNP(a2,MulNP(g2,y2),1,1);;


l12:=AddNP(MulNP(l1,l2),MulNP(l2,l1),1,-q12);;

l112:=AddNP(MulNP(l1,l12),MulNP(l12,l1),1,-q11*q12);;

l11212:=AddNP(MulNP(l112,l12),MulNP(l12,l112),1,-q11^2*q12^2*q21*q22);;

l:=StrongNormalFormNP(l11212,G);;


a12:=AddNP(MulNP(a1,a2),MulNP(a2,a1),1,-q12);;

a112:=AddNP(MulNP(a1,a12),MulNP(a12,a1),1,-q11*q12);;

a11212:=AddNP(MulNP(a112,a12),MulNP(a12,a112),1,-q11^2*q12^2*q21*q22);;

a:=StrongNormalFormNP(a11212,G);;


y12:=AddNP(MulNP(y1,y2),MulNP(y2,y1),1,-q12);;

y112:=AddNP(MulNP(y1,y12),MulNP(y12,y1),1,-q11*q12);;

y11212:=AddNP(MulNP(y112,y12),MulNP(y12,y112),1,-q11^2*q12^2*q21*q22);;



g1c:=MulNP(g1,MulNP(g1,g1));;

g2c:=MulNP(g2,g2);;

g11212:=MulNP(g1c,g2c);;


y:=StrongNormalFormNP(MulNP(g11212,y11212),G);;


z:=StrongNormalFormNP(AddNP(AddNP(l,y,1,-1),a,1,-1),G);;


Print("The difference is \n");


PrintNP(z);
